6 # Build LLVM the "Apple way".
9 # The first parameter is a space-separated list of the architectures the
10 # compilers will run on. For instance, "ppc i386". If the current machine
11 # isn't in the list, it will (effectively) be added.
12 # FIXME: HOSTS is not used in this script. Use it or Remove it.
15 # The second parameter is a space-separated list of the architectures the
16 # compilers will generate code for. If the current machine isn't in the list, a
17 # compiler for it will get built anyway, but won't be installed.
20 # The third parameter is the path to the compiler sources. There should be a
21 # shell script named 'configure' in this directory. This script makes a copy...
24 # The fourth parameter is the location where the LLVM will be installed. You can
25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
28 # The fifth parameter is the place where the compiler will be copied once it's
32 # The sixth parameter is a directory in which to place information (like
33 # unstripped executables and generated source files) helpful in debugging the
37 # The seventh parameter is a yes/no that indicates whether assertions should be
38 # enabled in the LLVM libs/tools.
41 # The eighth parameter is a yes/no that indicates whether this is an optimized
45 # The nineth parameter is the version number of the submission, e.g. 1007.
46 LLVM_SUBMIT_VERSION
="$9"
48 # The tenth parameter is the subversion number of the submission, e.g. 03.
49 LLVM_SUBMIT_SUBVERSION
="${10}"
51 # The current working directory is where the build will happen. It may already
52 # contain a partial result of an interrupted build, in which case this script
53 # will continue where it left off.
56 DARWIN_VERS
=`uname -r | sed 's/\..*//'`
57 echo DARWIN_VERS
= $DARWIN_VERS
59 # If we can find an LLVM-GCC, prefer it.
60 export CC
=/Developer
/usr
/bin
/llvm-gcc
61 if [ ! -x $CC ] ; then unset CC
; fi
62 export CXX
=/Developer
/usr
/bin
/llvm-g
++
63 if [ ! -x $CXX ] ; then unset CXX
; fi
65 DT_HOME
=$DEST_DIR/Developer
/usr
66 DEST_ROOT
="/Developer$DEST_ROOT"
67 if [ "x$DEVELOPER_BIN" != "x" ]; then
68 DT_HOME
=$DEST_DIR/$DEVELOPER_DIR/usr
69 DEST_ROOT
="/$DEVELOPER_DIR$DEST_ROOT"
72 ################################################################################
75 # Create the source tree we'll actually use to build, deleting
76 # tcl since it doesn't actually build properly in a cross environment
77 # and we don't really need it.
79 rm -rf $SRC_DIR ||
exit 1
80 mkdir
$SRC_DIR ||
exit 1
81 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ ||
exit 1
83 # Build the LLVM tree universal.
84 mkdir
-p $DIR/obj-llvm ||
exit 1
85 cd $DIR/obj-llvm ||
exit 1
87 if [ \
! -f Makefile.config
]; then
88 $SRC_DIR/configure
--prefix=$DT_HOME/local \
89 --enable-targets=arm
,x86
,powerpc
,cbe \
90 --enable-assertions=$LLVM_ASSERTIONS \
91 --enable-optimized=$LLVM_OPTIMIZED \
95 SUBVERSION
=`echo $RC_ProjectSourceVersion | sed -e 's/[^.]*\.\([0-9]*\).*/\1/'`
97 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
98 LLVM_SUBMIT_SUBVERSION
=`printf "%02d" $SUBVERSION`
99 RC_ProjectSourceVersion
=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
100 LLVM_SUBMIT_VERSION
=$RC_ProjectSourceVersion
103 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
104 LLVM_VERSION
="$LLVM_SUBMIT_VERSION"
106 LLVM_VERSION
="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
109 GCC_VER
=`cc --version 2>/dev/null | sed 1q`
111 if echo "$GCC_VER" |
grep GCC
> /dev
/null
; then
112 GCC_VER
=`echo $GCC_VER | sed -e 's/.*(GCC) \([0-9.][0-9.]*\).*/\1/'`
113 MAJ_VER
=`echo $GCC_VER | sed 's/\..*//'`
114 MIN_VER
=`echo $GCC_VER | sed 's/[^.]*\.\([0-9]*\).*/\1/'`
119 # Note: If compiling with GCC 4.0, don't pass the -jN flag. Building universal
120 # already has parallelism and we don't want to make the builders hit swap by
121 # firing off too many gccs at the same time.
122 if [ "x$MAJ_VER" != "x4" -o "x$MIN_VER" != "x0" ]; then
123 # Figure out how many make processes to run.
124 SYSCTL
=`sysctl -n hw.activecpu`
126 # hw.activecpu only available in 10.2.6 and later
127 if [ -z "$SYSCTL" ]; then
128 SYSCTL
=`sysctl -n hw.ncpu`
131 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
132 # Builders can default to 2, since even if they are single processor,
133 # nothing else is running on the machine.
134 if [ -z "$SYSCTL" ]; then
138 JOBS_FLAG
="-j $SYSCTL"
141 make $JOBS_FLAG $OPTIMIZE_OPTS UNIVERSAL
=1 UNIVERSAL_ARCH
="$TARGETS" \
142 LLVM_SUBMIT_VERSION
=$LLVM_SUBMIT_VERSION \
143 LLVM_SUBMIT_SUBVERSION
=$LLVM_SUBMIT_SUBVERSION \
144 CXXFLAGS
="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'" \
147 if ! test $?
== 0 ; then
148 echo "error: LLVM 'make' failed!"
152 ################################################################################
153 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
154 # $DEST_DIR, with occasional 'lipo' commands.
156 cd $DEST_DIR ||
exit 1
158 # Clean out DEST_DIR in case -noclean was passed to buildit.
161 cd $DIR/obj-llvm ||
exit 1
163 # Install the tree into the destination directory.
164 make $LOCAL_MAKEFLAGS $OPTIMIZE_OPTS UNIVERSAL
=1 UNIVERSAL_ARCH
="$TARGETS" \
165 LLVM_SUBMIT_VERSION
=$LLVM_SUBMIT_VERSION \
166 LLVM_SUBMIT_SUBVERSION
=$LLVM_SUBMIT_SUBVERSION \
167 OPTIMIZE_OPTION
='-O3' VERBOSE
=1 install
169 if ! test $?
== 0 ; then
170 echo "error: LLVM 'make install' failed!"
175 RC_ProjectSourceSubversion
=`printf "%d" $LLVM_SUBMIT_SUBVERSION`
176 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include
/llvm
/Version.h
177 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include
/llvm
/Version.h
179 if [ "x$LLVM_DEBUG" != "x1" ]; then
180 # Strip local symbols from llvm libraries.
181 strip
-S $DEST_DIR$DEST_ROOT/lib
/*.
[oa
]
182 for f
in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
187 # Copy over the tblgen utility.
188 cp `find $DIR -name tblgen` $DT_HOME/local
/bin
191 cd $DEST_DIR$DEST_ROOT
192 rm -f bin
/.dir etc
/llvm
/.dir lib
/.dir
194 # Remove PPC64 fat slices.
195 cd $DEST_DIR$DEST_ROOT/bin
196 if [ $MACOSX_DEPLOYMENT_TARGET = "10.4" ]; then
197 find .
-perm 755 -type f \
! \
( -name '*gccas' -o -name '*gccld' -o -name llvm-config \
) \
198 -exec lipo
-extract ppc
-extract i386
{} -output {} \
;
199 elif [ $MACOSX_DEPLOYMENT_TARGET = "10.5" ]; then
200 find .
-perm 755 -type f \
! \
( -name '*gccas' -o -name '*gccld' -o -name llvm-config \
) \
201 -exec lipo
-extract ppc7400
-extract i386
{} -output {} \
;
203 find .
-perm 755 -type f \
! \
( -name '*gccas' -o -name '*gccld' -o -name llvm-config \
) \
204 -exec lipo
-extract ppc7400
-extract i386
-extract x86_64
{} -output {} \
;
207 cd $DEST_DIR$DEST_ROOT
208 mkdir
-p $DT_HOME/lib
209 mv lib
/libLTO.dylib
$DT_HOME/lib
/libLTO.dylib
210 strip
-S $DT_HOME/lib
/libLTO.dylib
211 rm -f lib
/libLTO.a lib
/libLTO.la
213 # The Hello dylib is an example of how to build a pass. No need to install it.
214 rm lib
/libLLVMHello.dylib
217 MDIR
=$DEST_DIR$DEST_ROOT/share
/man
/man1
220 ################################################################################
221 # Create SYM_DIR with information required for debugging.
223 # Figure out how many make processes to run.
224 SYSCTL
=`sysctl -n hw.activecpu`
226 # hw.activecpu only available in 10.2.6 and later
227 if [ -z "$SYSCTL" ]; then
228 SYSCTL
=`sysctl -n hw.ncpu`
231 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
232 # can default to 2, since even if they are single processor, nothing else is
233 # running on the machine.
234 if [ -z "$SYSCTL" ]; then
238 cd $SYM_DIR ||
exit 1
240 # Clean out SYM_DIR in case -noclean was passed to buildit.
243 # Generate .dSYM files
244 find $DEST_DIR -perm -0111 -type f \
245 ! \
( -name '*.la' -o -name gccas
-o -name gccld
-o -name llvm-config
-o -name '*.a' \
) \
246 -print |
xargs -n 1 -P ${SYSCTL} dsymutil
248 # Save .dSYM files and .a archives
249 cd $DEST_DIR ||
exit 1
250 find . \
( -path \
*.dSYM
/\
* -or -name \
*.a \
) -print \
251 |
cpio -pdml $SYM_DIR ||
exit 1
254 mkdir
$SYM_DIR/src ||
exit 1
256 find obj-
* -name \
*.\
[chy\
] -o -name \
*.cpp
-print \
257 |
cpio -pdml $SYM_DIR/src ||
exit 1
259 ################################################################################
260 # Remove debugging information from DEST_DIR.
262 find $DEST_DIR -name \
*.a
-print |
xargs ranlib ||
exit 1
263 find $DEST_DIR -name \
*.dSYM
-print |
xargs rm -r ||
exit 1
264 chgrp
-h -R wheel
$DEST_DIR
265 chgrp
-R wheel
$DEST_DIR
267 ################################################################################
268 # Remove tar ball from docs directory
270 find $DEST_DIR -name html.
tar.gz
-exec rm {} \
;
272 ################################################################################